/* mapiterator.c generated by valac 0.56.17, the Vala compiler
 * generated from mapiterator.vala, do not modify */

/* mapiterator.vala
 *
 * Copyright (C) 2009  Didier Villevalois
 * Copyright (C) 2011  Maciej Piechotka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */

#include "gee.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gpointer gee_map_iterator_real_fold (GeeMapIterator* self,
                                     GType a_type,
                                     GBoxedCopyFunc a_dup_func,
                                     GDestroyNotify a_destroy_func,
                                     GeeFoldMapFunc f,
                                     gpointer f_target,
                                     gpointer seed);
static gboolean gee_map_iterator_real_foreach (GeeMapIterator* self,
                                        GeeForallMapFunc f,
                                        gpointer f_target);
static GType gee_map_iterator_get_type_once (void);

/**
 * Advances to the next entry in the iteration.
 *
 * @return ``true`` if the iterator has a next entry
 */
gboolean
gee_map_iterator_next (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 48 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 48 "mapiterator.vala"
	if (_iface_->next) {
#line 48 "mapiterator.vala"
		return _iface_->next (self);
#line 70 "mapiterator.c"
	}
#line 48 "mapiterator.vala"
	return FALSE;
#line 74 "mapiterator.c"
}

/**
 * Checks whether there is a next entry in the iteration.
 *
 * @return ``true`` if the iterator has a next entry
 */
gboolean
gee_map_iterator_has_next (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 55 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 55 "mapiterator.vala"
	if (_iface_->has_next) {
#line 55 "mapiterator.vala"
		return _iface_->has_next (self);
#line 94 "mapiterator.c"
	}
#line 55 "mapiterator.vala"
	return FALSE;
#line 98 "mapiterator.c"
}

/**
 * Returns the current key in the iteration.
 *
 * @return the current key in the iteration
 */
gpointer
gee_map_iterator_get_key (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 62 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 62 "mapiterator.vala"
	if (_iface_->get_key) {
#line 62 "mapiterator.vala"
		return _iface_->get_key (self);
#line 118 "mapiterator.c"
	}
#line 62 "mapiterator.vala"
	return NULL;
#line 122 "mapiterator.c"
}

/**
 * Returns the value associated with the current key in the iteration.
 *
 * @return the value for the current key
 */
gpointer
gee_map_iterator_get_value (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 69 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 69 "mapiterator.vala"
	if (_iface_->get_value) {
#line 69 "mapiterator.vala"
		return _iface_->get_value (self);
#line 142 "mapiterator.c"
	}
#line 69 "mapiterator.vala"
	return NULL;
#line 146 "mapiterator.c"
}

/**
 * Sets the value associated with the current key in the iteration.
 *
 * @param value the new value for the current key
 */
void
gee_map_iterator_set_value (GeeMapIterator* self,
                            gconstpointer value)
{
	GeeMapIteratorIface* _iface_;
#line 76 "mapiterator.vala"
	g_return_if_fail (self != NULL);
#line 76 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 76 "mapiterator.vala"
	if (_iface_->set_value) {
#line 76 "mapiterator.vala"
		_iface_->set_value (self, value);
#line 167 "mapiterator.c"
	}
}

/**
 * Unsets the current entry in the iteration. The cursor is set in an
 * in-between state. {@link get_key}, {@link get_value}, {@link set_value}
 * and {@link unset} will fail until the next move of the cursor (calling
 * {@link next}).
 */
void
gee_map_iterator_unset (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 84 "mapiterator.vala"
	g_return_if_fail (self != NULL);
#line 84 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 84 "mapiterator.vala"
	if (_iface_->unset) {
#line 84 "mapiterator.vala"
		_iface_->unset (self);
#line 189 "mapiterator.c"
	}
}

/**
 * Standard aggregation function.
 *
 * It takes a function, seed and first element, returns the new seed and
 * progress to next element when the operation repeats.
 *
 * Operation moves the iterator to last element in iteration. If iterator
 * points at some element it will be included in iteration.
 */
static gpointer
gee_map_iterator_real_fold (GeeMapIterator* self,
                            GType a_type,
                            GBoxedCopyFunc a_dup_func,
                            GDestroyNotify a_destroy_func,
                            GeeFoldMapFunc f,
                            gpointer f_target,
                            gpointer seed)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gpointer _tmp14_;
	gpointer result;
#line 118 "mapiterator.vala"
	_tmp0_ = gee_map_iterator_get_valid (self);
#line 118 "mapiterator.vala"
	_tmp1_ = _tmp0_;
#line 118 "mapiterator.vala"
	if (_tmp1_) {
#line 221 "mapiterator.c"
		gpointer _tmp2_;
		gpointer _tmp3_;
		gpointer _tmp4_;
		gpointer _tmp5_;
		gpointer _tmp6_;
		gpointer _tmp7_;
#line 119 "mapiterator.vala"
		_tmp2_ = gee_map_iterator_get_key (self);
#line 119 "mapiterator.vala"
		_tmp3_ = _tmp2_;
#line 119 "mapiterator.vala"
		_tmp4_ = gee_map_iterator_get_value (self);
#line 119 "mapiterator.vala"
		_tmp5_ = _tmp4_;
#line 119 "mapiterator.vala"
		_tmp6_ = seed;
#line 119 "mapiterator.vala"
		seed = NULL;
#line 119 "mapiterator.vala"
		_tmp7_ = f (_tmp3_, _tmp5_, _tmp6_, f_target);
#line 119 "mapiterator.vala"
		((seed == NULL) || (a_destroy_func == NULL)) ? NULL : (seed = (a_destroy_func (seed), NULL));
#line 119 "mapiterator.vala"
		seed = _tmp7_;
#line 119 "mapiterator.vala"
		((_tmp5_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) == NULL)) ? NULL : (_tmp5_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) (_tmp5_), NULL));
#line 119 "mapiterator.vala"
		((_tmp3_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) == NULL)) ? NULL : (_tmp3_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) (_tmp3_), NULL));
#line 250 "mapiterator.c"
	}
#line 120 "mapiterator.vala"
	while (TRUE) {
#line 254 "mapiterator.c"
		gpointer _tmp8_;
		gpointer _tmp9_;
		gpointer _tmp10_;
		gpointer _tmp11_;
		gpointer _tmp12_;
		gpointer _tmp13_;
#line 120 "mapiterator.vala"
		if (!gee_map_iterator_next (self)) {
#line 120 "mapiterator.vala"
			break;
#line 265 "mapiterator.c"
		}
#line 121 "mapiterator.vala"
		_tmp8_ = gee_map_iterator_get_key (self);
#line 121 "mapiterator.vala"
		_tmp9_ = _tmp8_;
#line 121 "mapiterator.vala"
		_tmp10_ = gee_map_iterator_get_value (self);
#line 121 "mapiterator.vala"
		_tmp11_ = _tmp10_;
#line 121 "mapiterator.vala"
		_tmp12_ = seed;
#line 121 "mapiterator.vala"
		seed = NULL;
#line 121 "mapiterator.vala"
		_tmp13_ = f (_tmp9_, _tmp11_, _tmp12_, f_target);
#line 121 "mapiterator.vala"
		((seed == NULL) || (a_destroy_func == NULL)) ? NULL : (seed = (a_destroy_func (seed), NULL));
#line 121 "mapiterator.vala"
		seed = _tmp13_;
#line 121 "mapiterator.vala"
		((_tmp11_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) == NULL)) ? NULL : (_tmp11_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) (_tmp11_), NULL));
#line 121 "mapiterator.vala"
		((_tmp9_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) == NULL)) ? NULL : (_tmp9_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) (_tmp9_), NULL));
#line 289 "mapiterator.c"
	}
#line 122 "mapiterator.vala"
	_tmp14_ = seed;
#line 122 "mapiterator.vala"
	seed = NULL;
#line 122 "mapiterator.vala"
	result = _tmp14_;
#line 122 "mapiterator.vala"
	((seed == NULL) || (a_destroy_func == NULL)) ? NULL : (seed = (a_destroy_func (seed), NULL));
#line 122 "mapiterator.vala"
	return result;
#line 301 "mapiterator.c"
}

gpointer
gee_map_iterator_fold (GeeMapIterator* self,
                       GType a_type,
                       GBoxedCopyFunc a_dup_func,
                       GDestroyNotify a_destroy_func,
                       GeeFoldMapFunc f,
                       gpointer f_target,
                       gpointer seed)
{
	GeeMapIteratorIface* _iface_;
#line 116 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 116 "mapiterator.vala"
	if (_iface_->fold) {
#line 116 "mapiterator.vala"
		return _iface_->fold (self, a_type, a_dup_func, a_destroy_func, f, f_target, seed);
#line 322 "mapiterator.c"
	}
#line 116 "mapiterator.vala"
	return NULL;
#line 326 "mapiterator.c"
}

/**
 * Apply function to each element returned by iterator. 
 *
 * Operation moves the iterator to last element in iteration. If iterator
 * points at some element it will be included in iteration.
 */
static gboolean
gee_map_iterator_real_foreach (GeeMapIterator* self,
                               GeeForallMapFunc f,
                               gpointer f_target)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 132 "mapiterator.vala"
	_tmp0_ = gee_map_iterator_get_valid (self);
#line 132 "mapiterator.vala"
	_tmp1_ = _tmp0_;
#line 132 "mapiterator.vala"
	if (_tmp1_) {
#line 349 "mapiterator.c"
		gpointer _tmp2_;
		gpointer _tmp3_;
		gpointer _tmp4_;
		gpointer _tmp5_;
		gboolean _tmp6_;
#line 133 "mapiterator.vala"
		_tmp2_ = gee_map_iterator_get_key (self);
#line 133 "mapiterator.vala"
		_tmp3_ = _tmp2_;
#line 133 "mapiterator.vala"
		_tmp4_ = gee_map_iterator_get_value (self);
#line 133 "mapiterator.vala"
		_tmp5_ = _tmp4_;
#line 133 "mapiterator.vala"
		_tmp6_ = !f (_tmp3_, _tmp5_, f_target);
#line 133 "mapiterator.vala"
		((_tmp5_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) == NULL)) ? NULL : (_tmp5_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) (_tmp5_), NULL));
#line 133 "mapiterator.vala"
		((_tmp3_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) == NULL)) ? NULL : (_tmp3_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) (_tmp3_), NULL));
#line 133 "mapiterator.vala"
		if (_tmp6_) {
#line 134 "mapiterator.vala"
			result = FALSE;
#line 134 "mapiterator.vala"
			return result;
#line 375 "mapiterator.c"
		}
	}
#line 137 "mapiterator.vala"
	while (TRUE) {
#line 380 "mapiterator.c"
		gpointer _tmp7_;
		gpointer _tmp8_;
		gpointer _tmp9_;
		gpointer _tmp10_;
		gboolean _tmp11_;
#line 137 "mapiterator.vala"
		if (!gee_map_iterator_next (self)) {
#line 137 "mapiterator.vala"
			break;
#line 390 "mapiterator.c"
		}
#line 138 "mapiterator.vala"
		_tmp7_ = gee_map_iterator_get_key (self);
#line 138 "mapiterator.vala"
		_tmp8_ = _tmp7_;
#line 138 "mapiterator.vala"
		_tmp9_ = gee_map_iterator_get_value (self);
#line 138 "mapiterator.vala"
		_tmp10_ = _tmp9_;
#line 138 "mapiterator.vala"
		_tmp11_ = !f (_tmp8_, _tmp10_, f_target);
#line 138 "mapiterator.vala"
		((_tmp10_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) == NULL)) ? NULL : (_tmp10_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_v_destroy_func (self) (_tmp10_), NULL));
#line 138 "mapiterator.vala"
		((_tmp8_ == NULL) || (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) == NULL)) ? NULL : (_tmp8_ = (GEE_MAP_ITERATOR_GET_INTERFACE (self)->get_k_destroy_func (self) (_tmp8_), NULL));
#line 138 "mapiterator.vala"
		if (_tmp11_) {
#line 139 "mapiterator.vala"
			result = FALSE;
#line 139 "mapiterator.vala"
			return result;
#line 412 "mapiterator.c"
		}
	}
#line 142 "mapiterator.vala"
	result = TRUE;
#line 142 "mapiterator.vala"
	return result;
#line 419 "mapiterator.c"
}

gboolean
gee_map_iterator_foreach (GeeMapIterator* self,
                          GeeForallMapFunc f,
                          gpointer f_target)
{
	GeeMapIteratorIface* _iface_;
#line 131 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 131 "mapiterator.vala"
	if (_iface_->foreach) {
#line 131 "mapiterator.vala"
		return _iface_->foreach (self, f, f_target);
#line 436 "mapiterator.c"
	}
#line 131 "mapiterator.vala"
	return FALSE;
#line 440 "mapiterator.c"
}

gboolean
gee_map_iterator_get_valid (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 91 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 91 "mapiterator.vala"
	if (_iface_->get_valid) {
#line 91 "mapiterator.vala"
		return _iface_->get_valid (self);
#line 455 "mapiterator.c"
	}
#line 91 "mapiterator.vala"
	return FALSE;
#line 459 "mapiterator.c"
}

gboolean
gee_map_iterator_get_mutable (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 98 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 98 "mapiterator.vala"
	if (_iface_->get_mutable) {
#line 98 "mapiterator.vala"
		return _iface_->get_mutable (self);
#line 474 "mapiterator.c"
	}
#line 98 "mapiterator.vala"
	return FALSE;
#line 478 "mapiterator.c"
}

gboolean
gee_map_iterator_get_read_only (GeeMapIterator* self)
{
	GeeMapIteratorIface* _iface_;
#line 105 "mapiterator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "mapiterator.vala"
	_iface_ = GEE_MAP_ITERATOR_GET_INTERFACE (self);
#line 105 "mapiterator.vala"
	if (_iface_->get_read_only) {
#line 105 "mapiterator.vala"
		return _iface_->get_read_only (self);
#line 493 "mapiterator.c"
	}
#line 105 "mapiterator.vala"
	return FALSE;
#line 497 "mapiterator.c"
}

static void
gee_map_iterator_default_init (GeeMapIteratorIface * iface,
                               gpointer iface_data)
{
	/**
	 * Determines whether the call to {@link get_key}, {@link get_value} and
	 * {@link set_value} is legal. It is false at the beginning and after
	 * {@link unset} call and true otherwise.
	 */
#line 42 "mapiterator.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 511 "mapiterator.c"
	/**
	 * Determines whether the call to {@link set_value} is legal assuming the
	 * iterator is valid. The value must not change in runtime hence the user
	 * of iterator may cache it.
	 */
#line 42 "mapiterator.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("mutable", "mutable", "mutable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 519 "mapiterator.c"
	/**
	 * Determines whether the call to {@link unset} is legal assuming the
	 * iterator is valid. The value must not change in runtime hence the user
	 * of iterator may cache it.
	 */
#line 42 "mapiterator.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "mapiterator.vala"
	iface->fold = gee_map_iterator_real_fold;
#line 42 "mapiterator.vala"
	iface->foreach = gee_map_iterator_real_foreach;
#line 531 "mapiterator.c"
}

/**
 * An iterator over a map.
 *
 * Gee's iterators are "on-track" iterators. They always point to an item
 * except before the first call to {@link next}, or, when an
 * item has been removed, until the next call to {@link next}.
 *
 * Please note that when the iterator is out of track, neither {@link get_key},
 * {@link get_value}, {@link set_value} nor {@link unset} are defined and all
 * will fail. After the next call to {@link next}, they will
 * be defined again.
 */
static GType
gee_map_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GeeMapIteratorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_map_iterator_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gee_map_iterator_type_id;
	gee_map_iterator_type_id = g_type_register_static (G_TYPE_INTERFACE, "GeeMapIterator", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gee_map_iterator_type_id, G_TYPE_OBJECT);
	return gee_map_iterator_type_id;
}

GType
gee_map_iterator_get_type (void)
{
	static volatile gsize gee_map_iterator_type_id__once = 0;
	if (g_once_init_enter (&gee_map_iterator_type_id__once)) {
		GType gee_map_iterator_type_id;
		gee_map_iterator_type_id = gee_map_iterator_get_type_once ();
		g_once_init_leave (&gee_map_iterator_type_id__once, gee_map_iterator_type_id);
	}
	return gee_map_iterator_type_id__once;
}

